diff -Naur tomato/release/src/router/pptp-client/config/pptpd_client.sh tomato121/release/src/router/pptp-client/config/pptpd_client.sh
--- tomato/release/src/router/pptp-client/config/pptpd_client.sh	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/pptpd_client.sh	2008-04-22 21:44:06.000000000 +1000
@@ -0,0 +1,26 @@
+#!/bin/sh
+USER=$(/usr/sbin/nvram get pptpd_client_srvuser)
+PASS=$(/usr/sbin/nvram get pptpd_client_srvpass)
+SEC=$(/usr/sbin/nvram get pptpd_client_srvsec)
+MTU=$(/usr/sbin/nvram get pptpd_client_srvmtu)
+MRU=$(/usr/sbin/nvram get pptpd_client_srvmru)
+sleep 30
+mkdir /tmp/pptpd_client
+mkdir /tmp/ppp
+cp /etc/config/pptpd_client.options /tmp/pptpd_client/options.vpn
+echo "$SEC"  >> /tmp/pptpd_client/options.vpn
+echo -n "mtu " >> /tmp/pptpd_client/options.vpn
+echo "$MTU"  >> /tmp/pptpd_client/options.vpn
+echo -n "mru " >> /tmp/pptpd_client/options.vpn
+echo "$MRU"  >> /tmp/pptpd_client/options.vpn
+echo -n "name "  >> /tmp/pptpd_client/options.vpn
+echo "$USER" >> /tmp/pptpd_client/options.vpn
+echo -n "password "  >> /tmp/pptpd_client/options.vpn
+echo "$PASS" >> /tmp/pptpd_client/options.vpn
+cp /etc/config/pptpd_client.vpn /tmp/pptpd_client/vpn
+chmod +x /tmp/pptpd_client/vpn
+cp /etc/config/pptpd_client.ip-up /tmp/pptpd_client/ip-up
+chmod +x /tmp/pptpd_client/ip-up
+cp /etc/config/pptpd_client.ip-down /tmp/pptpd_client/ip-down
+chmod +x /tmp/pptpd_client/ip-down
+pidof vpn || /tmp/pptpd_client/vpn start
diff -Naur tomato/release/src/router/pptp-client/config/pptpd_client.startup tomato121/release/src/router/pptp-client/config/pptpd_client.startup
--- tomato/release/src/router/pptp-client/config/pptpd_client.startup	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/pptpd_client.startup	2008-04-22 21:44:06.000000000 +1000
@@ -0,0 +1,24 @@
+#!/bin/sh
+if [ -z "$(nvram get pptpd_client_enable)" ]; then
+    nvram set pptpd_client_enable=0
+    nvram set pptpd_client_srvuser="DOMAIN\\\\Username"
+    nvram set pptpd_client_srvsec="mppe required"
+    nvram set pptpd_client_srvmtu="1450"
+    nvram set pptpd_client_srvmru="1450"
+    nvram set pptpd_client_nat="1"  
+    nvram need_commit=1
+fi
+
+if [ "$(nvram get pptpd_client_enable)" = "0" ]; then
+    if test -e "/tmp/pptpd_client/vpn"; then nohup /tmp/pptpd_client/vpn stop; fi
+fi
+
+if [ "$(nvram get pptpd_client_enable)" = "1" ]; then
+    if [ -z "$(nvram get pptpd_client_srvip)" ]
+    then
+     echo "No Ip or DNS name have been entered"
+    if test -e "/tmp/pptpd_client/vpn"; then nohup /tmp/pptpd_client/vpn stop; fi
+    else    
+    /etc/config/pptpd_client.sh &
+    fi
+fi
diff -Naur tomato/release/src/router/pptp-client/config/pptpd_client.vpn tomato121/release/src/router/pptp-client/config/pptpd_client.vpn
--- tomato/release/src/router/pptp-client/config/pptpd_client.vpn	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/pptpd_client.vpn	2008-04-22 21:44:06.000000000 +1000
@@ -0,0 +1,115 @@
+#!/bin/sh
+#######################################################################
+# VPN script Created by rcalvert                                      #
+# VPN Script and Related Scripts Modify by Cesar_G AKA Keloke         #
+# Module for DD-WRT created by Cesar_G AKA Keloke                     #
+#######################################################################
+
+RESP=0
+PPTPSERVER=$(nvram get pptpd_client_srvip)
+
+case $1 in
+ "start" )
+  echo "Launching VPN process"
+  $0 go &
+  echo "Process launched"
+;;
+
+ "go"  )
+  echo "Waiting......."
+  sleep 10
+  PIDFILE="/var/run/vpn.pid"
+  if [ -f "${PIDFILE}" ];
+  then
+   PID="`cat ${PIDFILE}`"
+   if egrep vpn "/proc/${PID}/cmdline" 2>&1 > /dev/null;
+   then
+    echo "Already active!"
+    exit 16
+   fi
+   echo "Removing PID file"
+   rm -f "${PIDFILE}"
+  fi
+  echo -n $$ > "${PIDFILE}"
+  echo "PID file created"
+  echo "Attempting initial connect"
+  pptp $PPTPSERVER file /tmp/pptpd_client/options.vpn
+  echo "Initial connection dropped"
+
+  while [ 1 ];
+  do
+   echo "Attempting connect... "
+   killall pptp 2>/dev/null
+   sleep 2
+   killall -9 pptp 2>/dev/null
+   sleep 1
+   pptp $PPTPSERVER file /tmp/pptpd_client/options.vpn
+   echo "Connection dropped... "
+   sleep 2
+  done;
+ ;;
+
+ "debug"  )
+  echo "Waiting......."
+  sleep 10
+  PIDFILE="/var/run/vpn.pid"
+  if [ -f "${PIDFILE}" ];
+  then
+   PID="`cat ${PIDFILE}`"
+   if egrep vpn "/proc/${PID}/cmdline" 2>&1 > /dev/null;
+   then
+    echo "Already active!"
+    exit 16
+   fi
+   echo "Removing PID file"
+   rm -f "${PIDFILE}"
+  fi
+  echo -n $$ > "${PIDFILE}"
+  echo "PID file created"
+  echo "Attempting initial connect"
+  pptp $PPTPSERVER file /tmp/pptpd_client/options.vpn debug nodetach
+  echo "Initial connection dropped"
+
+  while [ 1 ];
+  do
+   echo "Attempting connect... "
+   killall pptp 2>/dev/null
+   sleep 2
+   killall -9 pptp 2>/dev/null
+   sleep 1
+   pptp $PPTPSERVER file /tmp/pptpd_client/options.vpn debug nodetach
+   echo "Connection dropped... "
+   sleep 2
+  done;
+ ;;
+
+"stop"   )
+
+  VPNPID=`cat /var/run/vpn.pid`
+  echo "Killing VPN PID $VPNPID"
+  kill $VPNPID
+  sleep 2
+  kill -9 $VPNPID 2>/dev/null
+
+  PPTPPID=`pidof -s pptp`
+  echo "Killing PPTP PID $PPTPPID"
+  kill $PPTPPID
+  sleep 2
+  kill -9 $PPTPPID
+  sleep 2
+  rm /var/run/vpn.pid
+  echo "VPN Stopped"
+ ;; 
+* ) 
+  echo " "
+  echo "  PTPP VPN CLIENT" 
+  echo "  --------" 
+  echo " " 
+  echo "   start  -  Starts the Client" 
+  echo "   stop   -  Stops the Client" 
+  echo "   go     -  Run the Client interactively (for debugging)" 
+  echo "   debug  -  Run the Client interactively (in full debug mode)" 
+  echo " " 
+ ;; 
+esac
+return $RESP
diff -Naur tomato/release/src/router/pptp-client/config/vpn/ip-down tomato121/release/src/router/pptp-client/config/vpn/ip-down
--- tomato/release/src/router/pptp-client/config/vpn/ip-down	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/vpn/ip-down	2008-04-23 18:34:56.000000000 +1000
@@ -0,0 +1,18 @@
+#!/bin/sh
+REMOTESUB=$(/bin/nvram get pptp_client_srvsub)
+REMOTENET=$(/bin/nvram get pptp_client_srvsubmsk)
+case "$6" in
+ kelokepptpd)
+  /sbin/route del -net $REMOTESUB netmask $REMOTENET dev $1
+  /usr/sbin/iptables -D OUTPUT --source 0.0.0.0/0.0.0.0 --destination $REMOTESUB/$REMOTENET --jump ACCEPT --out-interface $1
+  /usr/sbin/iptables -D INPUT --source $REMOTESUB/$REMOTENET --destination 0.0.0.0/0.0.0.0 --jump ACCEPT --in-interface $1
+  /usr/sbin/iptables -D FORWARD --source 0.0.0.0/0.0.0.0 --destination $REMOTESUB/$REMOTENET --jump ACCEPT --out-interface $1
+  /usr/sbin/iptables -D FORWARD --source $REMOTESUB/$REMOTENET --destination 0.0.0.0/0.0.0.0 --jump ACCEPT --in-interface $1
+  /usr/sbin/iptables -D FORWARD --protocol tcp --tcp-flags SYN,RST SYN --jump TCPMSS --clamp-mss-to-pmtu
+  if [ "$(/bin/nvram get pptp_client_nat)" = "1" ]; then
+      /usr/sbin/iptables --table nat -D POSTROUTING --out-interface $1 --jump MASQUERADE
+  fi
+  ;;
+ *)
+esac   
+exit 0 
\ No newline at end of file
diff -Naur tomato/release/src/router/pptp-client/config/vpn/ip-up tomato121/release/src/router/pptp-client/config/vpn/ip-up
--- tomato/release/src/router/pptp-client/config/vpn/ip-up	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/vpn/ip-up	2008-04-23 18:35:18.000000000 +1000
@@ -0,0 +1,18 @@
+#!/bin/sh
+REMOTESUB=$(/bin/nvram get pptp_client_srvsub)
+REMOTENET=$(/bin/nvram get pptp_client_srvsubmsk)
+case "$6" in
+ kelokepptpd)
+  /sbin/route add -net $REMOTESUB netmask $REMOTENET dev $1
+  /usr/sbin/iptables --insert OUTPUT --source 0.0.0.0/0.0.0.0 --destination $REMOTESUB/$REMOTENET --jump ACCEPT --out-interface $1
+  /usr/sbin/iptables --insert INPUT --source $REMOTESUB/$REMOTENET --destination 0.0.0.0/0.0.0.0 --jump ACCEPT --in-interface $1
+  /usr/sbin/iptables --insert FORWARD --source 0.0.0.0/0.0.0.0 --destination $REMOTESUB/$REMOTENET --jump ACCEPT --out-interface $1
+  /usr/sbin/iptables --insert FORWARD --source $REMOTESUB/$REMOTENET --destination 0.0.0.0/0.0.0.0 --jump ACCEPT --in-interface $1
+  /usr/sbin/iptables --insert FORWARD --protocol tcp --tcp-flags SYN,RST SYN --jump TCPMSS --clamp-mss-to-pmtu 
+  if [ "$(/bin/nvram get pptp_client_nat)" = "1" ]; then
+      /usr/sbin/iptables --table nat --append POSTROUTING --out-interface $1 --jump MASQUERADE
+  fi
+  ;;
+ *)
+esac
+exit 0
diff -Naur tomato/release/src/router/pptp-client/config/vpn/options.vpn tomato121/release/src/router/pptp-client/config/vpn/options.vpn
--- tomato/release/src/router/pptp-client/config/vpn/options.vpn	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/vpn/options.vpn	2008-04-23 20:03:21.000000000 +1000
@@ -0,0 +1,15 @@
+lock
+noauth
+nodetach
+refuse-eap
+lcp-echo-failure 3
+lcp-echo-interval 2
+persist
+usepeerdns
+idle 0
+ip-up-script /etc/vpn/ip-up
+ip-down-script /etc/vpn/ip-down
+ipparam kelokepptpd
+
+mtu 1450
+mru 1450
diff -Naur tomato/release/src/router/pptp-client/config/vpn/vpn tomato121/release/src/router/pptp-client/config/vpn/vpn
--- tomato/release/src/router/pptp-client/config/vpn/vpn	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/config/vpn/vpn	2008-04-23 18:35:47.000000000 +1000
@@ -0,0 +1,115 @@
+#!/bin/sh
+#######################################################################
+# VPN script Created by rcalvert                                      #
+# VPN Script and Related Scripts Modify by Cesar_G AKA Keloke         #
+# Module for DD-WRT created by Cesar_G AKA Keloke                     #
+#######################################################################
+
+RESP=0
+PPTPSERVER=$(nvram get pptp_client_srvip)
+
+case $1 in
+ "start" )
+  echo "Launching VPN process"
+  $0 go &
+  echo "Process launched"
+;;
+
+ "go"  )
+  echo "Waiting......."
+  sleep 10
+  PIDFILE="/var/run/vpn.pid"
+  if [ -f "${PIDFILE}" ];
+  then
+   PID="`cat ${PIDFILE}`"
+   if egrep vpn "/proc/${PID}/cmdline" 2>&1 > /dev/null;
+   then
+    echo "Already active!"
+    exit 16
+   fi
+   echo "Removing PID file"
+   rm -f "${PIDFILE}"
+  fi
+  echo -n $$ > "${PIDFILE}"
+  echo "PID file created"
+  echo "Attempting initial connect"
+  pptp $PPTPSERVER file /etc/vpn/options.vpn
+  echo "Initial connection dropped"
+
+  while [ 1 ];
+  do
+   echo "Attempting connect... "
+   killall pptp 2>/dev/null
+   sleep 2
+   killall -9 pptp 2>/dev/null
+   sleep 1
+   pptp $PPTPSERVER file /etc/vpn/options.vpn
+   echo "Connection dropped... "
+   sleep 2
+  done;
+ ;;
+
+ "debug"  )
+  echo "Waiting......."
+  sleep 10
+  PIDFILE="/var/run/vpn.pid"
+  if [ -f "${PIDFILE}" ];
+  then
+   PID="`cat ${PIDFILE}`"
+   if egrep vpn "/proc/${PID}/cmdline" 2>&1 > /dev/null;
+   then
+    echo "Already active!"
+    exit 16
+   fi
+   echo "Removing PID file"
+   rm -f "${PIDFILE}"
+  fi
+  echo -n $$ > "${PIDFILE}"
+  echo "PID file created"
+  echo "Attempting initial connect"
+  pptp $PPTPSERVER file /etc/vpn/options.vpn debug nodetach
+  echo "Initial connection dropped"
+
+  while [ 1 ];
+  do
+   echo "Attempting connect... "
+   killall pptp 2>/dev/null
+   sleep 2
+   killall -9 pptp 2>/dev/null
+   sleep 1
+   pptp $PPTPSERVER file /etc/vpn/options.vpn debug nodetach
+   echo "Connection dropped... "
+   sleep 2
+  done;
+ ;;
+
+"stop"   )
+
+  VPNPID=`cat /var/run/vpn.pid`
+  echo "Killing VPN PID $VPNPID"
+  kill $VPNPID
+  sleep 2
+  kill -9 $VPNPID 2>/dev/null
+
+  PPTPPID=`pidof -s pptp`
+  echo "Killing PPTP PID $PPTPPID"
+  kill $PPTPPID
+  sleep 2
+  kill -9 $PPTPPID
+  sleep 2
+  rm /var/run/vpn.pid
+  echo "VPN Stopped"
+ ;; 
+* ) 
+  echo " "
+  echo "  PTPP VPN CLIENT" 
+  echo "  --------" 
+  echo " " 
+  echo "   start  -  Starts the Client" 
+  echo "   stop   -  Stops the Client" 
+  echo "   go     -  Run the Client interactively (for debugging)" 
+  echo "   debug  -  Run the Client interactively (in full debug mode)" 
+  echo " " 
+ ;; 
+esac
+return $RESP
diff -Naur tomato/release/src/router/pptp-client/DEVELOPERS tomato121/release/src/router/pptp-client/DEVELOPERS
--- tomato/release/src/router/pptp-client/DEVELOPERS	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/DEVELOPERS	2008-04-22 21:44:06.000000000 +1000
@@ -1,5 +1,3 @@
-$Id: DEVELOPERS,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
-
 Developers Information
 
 
@@ -82,7 +80,8 @@
 Developers who use IRC on a regular basis are welcome to add the
 project's channel to their list of autojoin channels.
 
-	Server: irc.openprojects.net
+	Server: irc.freenode.net
 	Channel: #pptp
 
---
+
+$Id: DEVELOPERS,v 1.4 2003/01/15 05:29:20 quozl Exp $
diff -Naur tomato/release/src/router/pptp-client/dirutil.c tomato121/release/src/router/pptp-client/dirutil.c
--- tomato/release/src/router/pptp-client/dirutil.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/dirutil.c	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /* dirutil.c ... directory utilities.
  *               C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: dirutil.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: dirutil.c,v 1.2 2003/06/17 17:25:47 reink Exp $
  */
 
 #include <sys/stat.h>
@@ -12,51 +12,57 @@
 #include "dirutil.h"
 
 /* Returned malloc'ed string representing basename */
-char *basenamex(char *pathname) {
-  char *dup = strdup(pathname);
-  char *ptr = strrchr(stripslash(dup), '/');
-  if (ptr==NULL) return dup;
-  ptr = strdup(ptr+1);
-  free(dup);
-  return ptr;
+char *basenamex(char *pathname)
+{
+    char *dup = strdup(pathname);
+    char *ptr = strrchr(stripslash(dup), '/');
+    if (ptr == NULL) return dup;
+    ptr = strdup(ptr+1);
+    free(dup);
+    return ptr;
 }
+
 /* Return malloc'ed string representing directory name (no trailing slash) */
-char *dirname(char *pathname) {
-  char *dup = strdup(pathname);
-  char *ptr = strrchr(stripslash(dup), '/');
-  if (ptr==NULL) { free(dup); return strdup("."); }
-  if (ptr==dup && dup[0]=='/') ptr++;
-  *ptr = '\0';
-  return dup;
+char *dirname(char *pathname)
+{
+    char *dup = strdup(pathname);
+    char *ptr = strrchr(stripslash(dup), '/');
+    if (ptr == NULL) { free(dup); return strdup("."); }
+    if (ptr == dup && dup[0] == '/') ptr++;
+    *ptr = '\0';
+    return dup;
 }
+
 /* In-place modify a string to remove trailing slashes.  Returns arg.
  * stripslash("/") returns "/";
  */
 char *stripslash(char *pathname) {
-  int len = strlen(pathname);
-  while (len > 1 && pathname[len-1]=='/')
-    pathname[--len]='\0';
-  return pathname;
+    int len = strlen(pathname);
+    while (len > 1 && pathname[len - 1] == '/')
+        pathname[--len] = '\0';
+    return pathname;
 }
+
 /* ensure dirname exists, creating it if necessary. */
-int make_valid_path(char *dir, mode_t mode) {
-  struct stat st;
-  char *tmp=NULL, *path = stripslash(strdup(dir));
-  int retval;
-  if (stat(path, &st) == 0) { /* file exists */
-    if (S_ISDIR(st.st_mode)) { retval=1; goto end; }
-    else { retval=0; goto end; } /* not a directory.  Oops. */
-  }
-  /* Directory doesn't exist.  Let's make it. */
-  /*   Make parent first. */
-  if (!make_valid_path(tmp = dirname(path), mode)) { retval=0; goto end; }
-  /*   Now make this 'un. */
-  if (mkdir(path, mode) < 0) { retval=0; goto end; }
-  /* Success. */
-  retval=1;
+int make_valid_path(char *dir, mode_t mode)
+{
+    struct stat st;
+    char *tmp = NULL, *path = stripslash(strdup(dir));
+    int retval;
+    if (stat(path, &st) == 0) { /* file exists */
+        if (S_ISDIR(st.st_mode)) { retval = 1; goto end; }
+        else { retval = 0; goto end; } /* not a directory.  Oops. */
+    }
+    /* Directory doesn't exist.  Let's make it. */
+    /*   Make parent first. */
+    if (!make_valid_path(tmp = dirname(path), mode)) { retval = 0; goto end; }
+    /*   Now make this 'un. */
+    if (mkdir(path, mode) < 0) { retval = 0; goto end; }
+    /* Success. */
+    retval = 1;
 
 end:
-  if (tmp!=NULL) free(tmp);
-  if (path!=NULL) free(path);
-  return retval;
+    if (tmp != NULL) free(tmp);
+    if (path != NULL) free(path);
+    return retval;
 }
diff -Naur tomato/release/src/router/pptp-client/dirutil.h tomato121/release/src/router/pptp-client/dirutil.h
--- tomato/release/src/router/pptp-client/dirutil.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/dirutil.h	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /* dirutil.h ... directory utilities.
  *               C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: dirutil.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: dirutil.h,v 1.1.1.1 2000/12/23 08:19:51 scott Exp $
  */
 
 /* Returned malloc'ed string representing basename */
diff -Naur tomato/release/src/router/pptp-client/Documentation/PORTING tomato121/release/src/router/pptp-client/Documentation/PORTING
--- tomato/release/src/router/pptp-client/Documentation/PORTING	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/Documentation/PORTING	2008-04-22 21:44:06.000000000 +1000
@@ -1,5 +1,5 @@
-pptp-linux uses very few linux-specific features, and should be
-easily portable to most Unix systems.
+pptp uses very few linux-specific features, and should be easily
+portable to most Unix systems.
 
 Two things to watch:
   1)
diff -Naur tomato/release/src/router/pptp-client/INSTALL tomato121/release/src/router/pptp-client/INSTALL
--- tomato/release/src/router/pptp-client/INSTALL	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/INSTALL	2008-04-22 21:44:06.000000000 +1000
@@ -1,9 +1,45 @@
-First, install pppd (the Point-to-Point Protocol package) and make
-sure it is working.  You will need MS-CHAP support in pppd to use
-encrypted authentication for pptp. 
-
-Look at the Makefile; make sure its settings are correct.  In
-particular, if your pppd program in not installed in either /bin or
-/usr/bin, edit the path in PPPD_BINARY to point to your pppd program.
+Installation Instructions - Brief
 
-Type 'make'.  This should generate the 'pptp' executable.
+    1.  install pppd (with MPPE if you require it),
+    2.  if pppd is not in /usr/sbin, edit Makefile, variable PPPD,
+    3.  'make'
+    4.  'make install'
+
+
+Installation Instructions - Detailed
+
+    1.  install PPP, and make sure it is working.
+
+        On most distributions, use the package called ppp or pppd.
+
+        If your PPTP server requires MPPE, make sure the pppd program
+        has been built with MPPE and MS-CHAP support.  PPP from
+        version 2.4.2 onwards has this support.  PPP may require
+        kernel support for MPPE, which may require patching your
+        kernel.
+
+    2.  verify that the pppd program is in the /usr/sbin/ directory.
+
+        On some distributions, it is in /usr/bin, or somewhere else.
+        If it isn't in the default directory, edit the Makefile, and
+        change the PPPD variable to point at the pppd program.
+
+        You may even want to run a separate pppd program with MPPE
+        support.
+
+    3.  compile
+
+        Type 'make'.  This should generate the 'pptp' executable.
+
+    4.  install binaries
+
+	Type 'make install' to have the program and the manual page
+	installed.
+
+
+Further information
+
+    http://pptpclient.sourceforge.net/
+
+
+$Id: INSTALL,v 1.2 2003/01/15 05:29:20 quozl Exp $	
diff -Naur tomato/release/src/router/pptp-client/inststr.c tomato121/release/src/router/pptp-client/inststr.c
--- tomato/release/src/router/pptp-client/inststr.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/inststr.c	2008-04-22 21:44:06.000000000 +1000
@@ -1,11 +1,16 @@
 /* inststr.c ... stolen from bdupdate.c, which stole it from perl 4.
  *               Theft by C. Scott Ananian <cananian@alumni.princeton.edu>
+ *               Modified similarly to perl 5.8.3's alignment-checking code
+8                by Paul Howarth <paul@city-fan.org>
  *
- * $Id: inststr.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: inststr.c,v 1.3 2004/06/08 23:40:14 quozl Exp $
  */
 
 #include <string.h>
 
+#define PTRSIZE sizeof(void *)
+typedef unsigned long UL;
+
 void
 inststr(int argc, char **argv, char **environ, char *src)
 {
@@ -18,22 +23,46 @@
         strcpy(argv[0], src);
     } else
     {
-        /* stolen from the source to perl 4.036 (assigning to $0) */
+        /* Stolen from the source to perl 4.036 (assigning to $0) */
+        /* Modified to allow for aligned array members, assuming  */
+        /* no system has something bizarre like the argv[]        */
+        /* interleaved with some other data. Also allow for argv  */
+        /* array having higher numbered elements lower in memory  */
+        /* than lower numbered elements.                          */
         char *ptr, *ptr2;
         int count;
+        UL mask = ~(UL)(PTRSIZE == 4 ? 3 : PTRSIZE == 8 ? 7 : PTRSIZE == 16 ? 15 : 0);
+        int aligned = (mask < ~(UL)0) && (((UL)(argv[0]) & mask) == (UL)(argv[0]));
         ptr = argv[0] + strlen(argv[0]);
-        for (count = 1; count < argc; count++) {
-               if (argv[count] == ptr + 1) {
-                   int fwd = strlen(++ptr);
-                   ptr += fwd; 
-               }
+        if (argv[argc - 1] >= argv[1]) {
+            /* argv pointers in ascending memory order */
+            for (count = 1; count < argc; count++) {
+                if (argv[count] == ptr + 1
+                    ||
+                    (aligned && argv[count] > ptr && argv[count] <= (char *)((UL)(ptr + PTRSIZE) & mask))
+                   ) {
+                    ptr = argv[count] + strlen(argv[count]);
+                }
+            }
+        } else
+        {
+            /* sometimes the argv pointers go down in memory rather than up */
+            for (count = argc - 1; count > 0; count--) {
+                if (argv[count] == ptr + 1
+                    ||
+                    (aligned && argv[count] > ptr && argv[count] <= (char *)((UL)(ptr + PTRSIZE) & mask))
+                   ) {
+                    ptr = argv[count] + strlen(argv[count]);
+                }
+            }
         }
-        if (environ[0] == ptr + 1) {
-            for (count = 0; environ[count]; count++)
-                if (environ[count] == ptr + 1) {
-                   int fwd = strlen(++ptr);
-                   ptr += fwd; 
-               }
+        for (count = 0; environ[count]; count++) {
+            if (environ[count] == ptr + 1
+                ||
+                (aligned && environ[count] > ptr && environ[count] <= (char *)((UL)(ptr + PTRSIZE) & mask))
+               ) {
+                   ptr = environ[count] + strlen(environ[count]);
+            }
         }
         count = 0;
         for (ptr2 = argv[0]; ptr2 <= ptr; ptr2++) {
diff -Naur tomato/release/src/router/pptp-client/inststr.h tomato121/release/src/router/pptp-client/inststr.h
--- tomato/release/src/router/pptp-client/inststr.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/inststr.h	2008-04-22 21:44:06.000000000 +1000
@@ -1,6 +1,6 @@
 /* inststr.h ..... change argv[0].
  *
- * $Id: inststr.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: inststr.h,v 1.1.1.1 2000/12/23 08:19:51 scott Exp $
  */
 
 void inststr(int argc, char **argv, char **envp, char *src);
diff -Naur tomato/release/src/router/pptp-client/Makefile tomato121/release/src/router/pptp-client/Makefile
--- tomato/release/src/router/pptp-client/Makefile	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/Makefile	2008-04-22 21:44:06.000000000 +1000
@@ -1,30 +1,36 @@
-VERSION = 1.1.0
-
-CT_SPEC = 1
+# $Id: Makefile,v 1.38 2005/03/10 01:18:20 quozl Exp $
+VERSION=1.7.0
+RELEASE=
 
 #################################################################
 # CHANGE THIS LINE to point to the location of your pppd binary.
 PPPD = /usr/sbin/pppd
 #################################################################
 
-#CROSS =mipsel-linux-
-#CC = $(CROSS)gcc -s
+BINDIR=$(DESTDIR)/usr/sbin
+MANDIR=$(DESTDIR)/usr/share/man/man8
+PPPDIR=$(DESTDIR)/etc/ppp
+
+#CC	= gcc
 RM	= rm -f
+OPTIMIZE= $(COPTS) -ffunction-sections -fdata-sections -Wl,--gc-sections
+
+#OPTIMIZE= -O0
 DEBUG	= -g
 INCLUDE =
-CFLAGS  = -Wall -O1 $(DEBUG) $(INCLUDE)	-I$(SRCBASE)/include
-LIBS	=
-#LDFLAGS	= -lutil
+CFLAGS  = -Wall $(OPTIMIZE) $(DEBUG) $(INCLUDE)
+LIBS	= -lutil -ffunction-sections -fdata-sections -Wl,--gc-sections
+LDFLAGS	=
 
 PPTP_BIN = pptp
 
 PPTP_OBJS = pptp.o pptp_gre.o ppp_fcs.o \
             pptp_ctrl.o dirutil.o vector.o \
             inststr.o util.o version.o \
-	    pptp_quirks.o orckit_quirks.o
+	    pptp_quirks.o orckit_quirks.o pqueue.o pptp_callmgr.o
 
 PPTP_DEPS = pptp_callmgr.h pptp_gre.h ppp_fcs.h util.h \
-	    pptp_quirks.h orckit_quirks.h config.h pptp_options.h
+	    pptp_quirks.h orckit_quirks.h config.h pqueue.h
 
 all: config.h $(PPTP_BIN)
 
@@ -33,56 +39,52 @@
 
 config.h: 
 	echo "/* text added by Makefile target config.h */" > config.h
-	echo "#define PPTP_LINUX_VERSION \"$(VERSION)\"" >> config.h
+	echo "#define PPTP_LINUX_VERSION \"$(VERSION)$(RELEASE)\"" >> config.h
 	echo "#define PPPD_BINARY \"$(PPPD)\"" >> config.h
 
 vector_test: vector_test.o vector.o
 	$(CC) -o vector_test vector_test.o vector.o
 
 clean:
-	$(RM) *.o pptp
+	$(RM) *.o config.h
 
 clobber: clean
 	$(RM) $(PPTP_BIN) vector_test
 
 distclean: clobber
-	$(RM) pptp-linux-*.tar.gz
-	$(RM) -r pptp-linux-*
 
 test: vector_test
 
-dist: clobber
-	$(RM) pptp-linux-$(VERSION).tar.gz
-	$(RM) -r pptp-linux-$(VERSION)
-	mkdir pptp-linux-$(VERSION)
-	mkdir pptp-linux-$(VERSION)/Documentation
-	mkdir pptp-linux-$(VERSION)/Reference
-	cp \
-AUTHORS COPYING INSTALL Makefile NEWS README TODO USING		\
-dirutil.c dirutil.h inststr.c inststr.h ppp_fcs.c ppp_fcs.h	\
-pptp.c pptp_callmgr.c pptp_callmgr.h pptp_ctrl.c pptp_ctrl.h	\
-pptp_gre.c pptp_gre.h pptp_msg.h pptp_options.h			\
-util.c util.h vector.c vector.h vector_test.c	\
-version.c version.h \
-  pptp-linux-$(VERSION)
-	cp \
-Documentation/DESIGN.CALLMGR	\
-Documentation/DESIGN.PPTP	\
-Documentation/PORTING	\
-  pptp-linux-$(VERSION)/Documentation
-	cp \
-Reference/README	\
-Reference/ms-chap.txt	\
-Reference/pptp-draft.txt	\
-Reference/rfc1661.txt	\
-Reference/rfc1662.txt	\
-Reference/rfc1701.txt	\
-Reference/rfc1702.txt	\
-Reference/rfc1990.txt	\
-Reference/rfc791.txt	\
-Reference/rfc793.txt	\
-  pptp-linux-$(VERSION)/Reference
-	tar czf pptp-linux-$(VERSION).tar.gz pptp-linux-$(VERSION)
-	$(RM) -r pptp-linux-$(VERSION)
+install:
+	mkdir -p $(BINDIR)
+	install -o root -m 555 pptp $(BINDIR)
+	mkdir -p $(MANDIR)
+	install -m 644 pptp.8 $(MANDIR)
+	mkdir -p $(PPPDIR)
+	install -m 644 options.pptp $(PPPDIR)
+
+uninstall:
+	$(RM) $(BINDIR)/pptp $(MANDIR)/pptp.8
 
-pptp_ctrl.o: $(SRCBASE)/include/cyutils.h
+dist: clobber
+	$(RM) pptp-$(VERSION)$(RELEASE).tar.gz
+	$(RM) -r pptp-$(VERSION)
+	mkdir pptp-$(VERSION)
+	cp --recursive ChangeLog Makefile *.c *.h options.pptp pptp.8 \
+		Documentation Reference AUTHORS COPYING INSTALL NEWS \
+		README DEVELOPERS TODO USING \
+		pptp-$(VERSION)/
+	$(RM) -r pptp-$(VERSION)/CVS pptp-$(VERSION)/*/CVS
+	tar czf pptp-$(VERSION)$(RELEASE).tar.gz pptp-$(VERSION)
+	$(RM) -r pptp-$(VERSION)
+	md5sum pptp-$(VERSION)$(RELEASE).tar.gz
+
+deb:
+	chmod +x debian/rules 
+	fakeroot dpkg-buildpackage -us -uc
+	mv ../pptp_$(VERSION)-0_i386.deb .
+
+WEB=~/public_html/external/mine/pptp/pptpconfig
+release:
+	cp pptp_$(VERSION)-0_i386.deb $(WEB)
+	cd $(WEB);make
diff -Naur tomato/release/src/router/pptp-client/NEWS tomato121/release/src/router/pptp-client/NEWS
--- tomato/release/src/router/pptp-client/NEWS	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/NEWS	2008-04-22 21:44:06.000000000 +1000
@@ -1,4 +1,75 @@
-Release 1.1.0:
+Release 1.7.0: (27th July 2005)
+
+- silently discard packets not for the call [Cameron/Jenkins]
+- adopt sigpipe for use with SIGALRM on control connection [Wolter/Cameron]
+- fixes known valgrind heap violations in 1.6.0 [Cameron/Thorne]
+- properly report control connection echo reply loss [Wolter]
+
+Release 1.6.0: (18th February 2005)
+
+- fix double-free on stop control connection reply [Kivity]
+- add --idle-wait option [Cameron]
+- fix segfault on fatal connection error [Kivity]
+- prevent a possible signal race [Kivity]
+- prevent kill of init [Shurdeek]
+- portability fix for non-Linux systems [Quinot]
+- rename package from pptp-linux to pptp [Cameron]
+
+Release 1.5.0: (22nd June 2004)
+
+- fix statistics when buffering disabled [Wilson]
+- do not inherit the GRE socket [Cameron]
+- fix a case of non-shutdown of call manager [Klazes]
+- add --nobuffer option to eliminate all buffering of packets [Wilson]
+- fix corruption of command line as shown by ps [Howarth]
+- fix CPU loop after pppd killed [Cameron]
+- fix compile for ARM architecture [Hopf]
+- add documentation for command-line options [Wilson]
+- do not hang when a connection is refused [McCurdy]
+- better describe a cause of EMSGSIZE [Cameron]
+
+Release 1.4.0: (2nd January 2004)
+
+- support options before hostname [Wilson]
+- defer OCRQ until after SCCRP [Cameron]
+- include uninstall target [Pieter]
+- only issue a warning if sync mode is different to pppd [Klazes]
+- reformat and tidy code [Klazes]
+- reduce transmitted ack-only packets from 40% to 0.8% [Klazes]
+
+Release 1.3.1: (11th June 2003)
+
+- fixed bug introduced since 1.2.0 that prevented simultaneous tunnels.
+
+Release 1.3.0: (10th June 2003)
+
+- rewrite command usage text.
+- increase call disconnect notification log message verbosity.
+- inherit more make command line options.
+- remove execute permissions on man page.
+- fixed inefficient acknowledgement immediately followed by data packet.
+- added statistics for link quality monitoring.
+- remove include of callmgr, do separate compile.
+- remove duplicate messages caused by code in header file.
+- compilation fixes for Apple MacOS X.
+- support multiple clients on alias IP addresses.
+
+Release 1.2.0: (14th February 2003)
+
+- subsecond packet timeout to improve performance on fast links.
+- rewrite INSTALL.
+- add man page to install target.
+- fix response to dropped packets.
+- fix man page, address must be before options.
+- adopt man page contributed by Thomas Quinot.
+- close stderr to prevent holding open ssh sessions.
+- minor hint added in case of EIO on read() of pty.
+- support synchronous HDLC ppp encoding. Synchronous mode results in an
+  important improvement of the CPU efficiency.
+- handle out-of-order packets arriving on the GRE socket by buffering.
+- bind GRE socket early to prevent ICMP Unreachable response by client.
+
+Release 1.1.0: (20th March 2002)
 
 - New release engineer.
 - allow activation as a psuedo-tty child process from pppd.
@@ -11,7 +82,7 @@
 - integrated call manager into pptp binary.
 - many bugfixes improving stability.
 
-Release 1.0.3:
+Release 1.0.3: (7th May 2001)
 
 - New maintaining team.
 - Various bug fixes from the Debian package and FreeBSD port.
@@ -37,3 +108,4 @@
 
 - This is the first public release of the pptp-linux package.
 
+$Id: NEWS,v 1.44 2005/07/27 10:51:44 quozl Exp $	
